#!/bin/bash -e
#   * compile instructions: put this file in
#   *         `steamapps/common/Dyson Sphere Program/CustomMod`
#   * folder, open a terminal in the same folder, and execute:
#   *
#   * ```
#   *     chmod +x oni.cs
#   *     ./oni.cs
#   * ```
#   *
#   * then the mod will be compiled automatically.
#   *
#   * Here we wrote a shebang like file, which is correct
#   * in my computer (Manjaro XFCE), if such script do not work
#   * in your computer, you could just try the instructions below :

if [ -z "$__DOTNET_CSC" ]; then
    export __DOTNET_CSC="`find /usr/share/dotnet -type f -name dotnet` `find /usr/share/dotnet -name csc.dll`"
    echo '$'"__DOTNET_CSC not set yet, you should execute"
    echo "export __DOTNET_CSC='$__DOTNET_CSC'"
    echo "manually, or this alert will occur each time you execute this script."
fi

__MODE_VERBOSE=61 # may be modified, check it carefully.
__MODE_DEBUG__=62
__MODE_RELEASE=63

case $1 in
    V)       _MODE__SELECT_=$__MODE_VERBOSE     ;;
    v)       _MODE__SELECT_=$__MODE_VERBOSE     ;;
    VERBOSE) _MODE__SELECT_=$__MODE_VERBOSE     ;;
    verbose) _MODE__SELECT_=$__MODE_VERBOSE     ;;
    D)       _MODE__SELECT_=$__MODE_DEBUG__     ;;
    d)       _MODE__SELECT_=$__MODE_DEBUG__     ;;
    DEBUG)   _MODE__SELECT_=$__MODE_DEBUG__     ;;
    debug)   _MODE__SELECT_=$__MODE_DEBUG__     ;;
    *)       _MODE__SELECT_=$__MODE_RELEASE     ;;
esac

FILE_NAME=$0

# ( yes "" | head -n $_MODE__SELECT_ | head -n-1  ; tail $FILE_NAME -n+$_MODE__SELECT_ ) | head -n 55

( yes "" | head -n $_MODE__SELECT_ | head -n-1  ; tail $FILE_NAME -n+$_MODE__SELECT_ ) | $__DOTNET_CSC -nologo -t:library \
  -r:'../../OxygenNotIncluded_Data/Managed/0Harmony.dll' \
  -r:'../../OxygenNotIncluded_Data/Managed/System.dll' \
  -r:'../../OxygenNotIncluded_Data/Managed/System.Core.dll' \
  -r:'../../OxygenNotIncluded_Data/Managed/UnityEngine.dll' \
  -r:'../../OxygenNotIncluded_Data/Managed/UnityEngine.CoreModule.dll' \
  -r:'../../OxygenNotIncluded_Data/Managed/mscorlib.dll' \
  -r:'../../OxygenNotIncluded_Data/Managed/Assembly-CSharp.dll' \
  -r:'../../OxygenNotIncluded_Data/Managed/Assembly-CSharp-firstpass.dll' \
  -out:'./'"${FILE_NAME%.*}".dll \
  -optimize \
  -

cp -f * ~/.config/unity3d/Klei/Oxygen\ Not\ Included/mods/Local/local-simple
exit



#define VERBOSE
#define DEBUG



using KMod;
using HarmonyLib;
using UnityEngine;

using System;
using System.Reflection;
using System.Reflection.Emit;
using System.Collections.Generic;
using Database;

using Klei.AI;


namespace ONIMod
{
    public class MyUserMod : UserMod2 {
        public override void OnLoad(Harmony harmony)
        {
            Harmony.DEBUG = true;
            base.OnLoad(harmony);
            Debug.Log("Neutron3529's simple ONI mod is loaded.");
        }
        [HarmonyDebug]
        [HarmonyPatch(typeof(MinionConfig), "AddMinionTraits")]
        class MinionConfigAddMinionTraits{
            static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions){//机械臂拾取范围扩大
                Debug.Log("Neutron3529:开始注入MinionConfig的AddMinionTraits");
                uint flag=0xDEADBEFF;
                MethodInfo ModifierSetCreateTrait = typeof(ModifierSet).GetMethod("CreateTrait");
                foreach (var instruction in instructions) {
                    yield return instruction;// name=((FieldInfo)instruction.operand).Name;
                    if(flag==0xDEADBEFF && instruction.opcode==OpCodes.Callvirt && (MethodInfo)instruction.operand == ModifierSetCreateTrait){
                        Debug.Log("       [II]:开始复制人trait的函数注入.");
                        flag=0;
                        //yield return new CodeInstruction(OpCodes.Dup,null); // trait
                        yield return new CodeInstruction(OpCodes.Ldarg_1,null);// modifiers
                        yield return new CodeInstruction(OpCodes.Call,typeof(MinionConfigAddMinionTraits).GetMethod("insert"));// call insert(trait,modifiers), return trait thus no more op is required.
                    }
                }
            }
            public static Trait insert(Trait trait,Modifiers modifiers){//机械臂拾取范围扩大
                string name="Mod";
                trait.Add(new AttributeModifier(Db.Get().Amounts.Calories.maxAttribute.Id, 396000000f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Amounts.Toxicity.deltaAttribute.Id, 1f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Amounts.Stress.deltaAttribute.Id, -1f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Amounts.Breath.deltaAttribute.Id, 0.8f, name, false, false, true));//普通复制人是0.9f，0.8f可以保证憋气时间x10
                trait.Add(new AttributeModifier(Db.Get().Amounts.Bladder.deltaAttribute.Id, -1f, name, false, false, true));//普通复制人是0.9f，0.8f可以保证憋气时间x10
                trait.Add(new AttributeModifier(Db.Get().Amounts.HitPoints.maxAttribute.Id, 9900f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Amounts.Stamina.deltaAttribute.Id, 1f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Amounts.Decor.deltaAttribute.Id, 100f, name, false, false, true));

                trait.Add(new AttributeModifier(Db.Get().Attributes.RadiationResistance.Id, 1000f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Attributes.RadiationRecovery.Id, -1000f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Attributes.SpaceNavigation.Id,1000f,name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Attributes.DecorExpectation.Id, 10f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Attributes.FoodExpectation.Id, 10f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Attributes.MaxUnderwaterTravelCost.Id, 30f, name, false, false, true));
                trait.Add(new AttributeModifier(Db.Get().Attributes.QualityOfLife.Id, 10f, name, false, false, true));

                // 下面是没有放在 modifiers.initialAttributes 的变量，不处理initialAttributes的话，读档会消失。

                modifiers.initialAttributes.Add(Db.Get().Attributes.Construction.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Construction.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Digging.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Digging.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Machinery.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Machinery.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Athletics.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Athletics.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Learning.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Learning.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Cooking.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Cooking.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Caring.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Caring.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Strength.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Strength.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Art.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Art.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Botanist.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Botanist.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Ranching.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Ranching.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.LifeSupport.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.LifeSupport.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Toggle.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Toggle.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.PowerTinker.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.PowerTinker.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.FarmTinker.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.FarmTinker.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Immunity.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Immunity.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.GermResistance.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.GermResistance.Id,100f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.Insulation.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.Insulation.Id,1000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.ThermalConductivityBarrier.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.ThermalConductivityBarrier.Id,10000f,name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.ToiletEfficiency.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.ToiletEfficiency.Id, 30f, name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.DiseaseCureSpeed.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.DiseaseCureSpeed.Id, 30f, name, false, false, true));
                modifiers.initialAttributes.Add(Db.Get().Attributes.DoctoredLevel.Id);
                  trait.Add(new AttributeModifier(Db.Get().Attributes.DoctoredLevel.Id, 10f, name, false, false, true));

                trait.OnAddTrait = delegate(GameObject go) {
                    MinionResume component = go.GetComponent<MinionResume>();
                    if (component != null) {
                        Dictionary<string, bool> ownedHats = Traverse.Create(component).Field("ownedHats").GetValue<Dictionary<string, bool>>();
                        for(int i=0;i<Db.Get().Skills.Count;i++){
                            string skillId = Db.Get().Skills[i].Id;
                            component.MasteryBySkillID[skillId] = true;
                            //component.GrantSkill(skillId);
                            component.GrantedSkillIDs.Add(skillId);
                            if (!ownedHats.ContainsKey(Db.Get().Skills.Get(skillId).hat)) {
                                ownedHats.Add(Db.Get().Skills.Get(skillId).hat, false);
                            }
                        }
                    }
                };
                return trait;
            }
        }
    }
}

